var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F01409;
(function (F01409) {
    var InterfaceRules = (function (_super) {
        __extends(InterfaceRules, _super);
        function InterfaceRules() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._canAddPurchaseObject = true;
            return _this;
        }
        InterfaceRules.prototype.SheetP1FormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                    return SheetFormatCollection.Default;
                default:
                    var rowCount = this.Document.Sheets.getValue(sheetId).RowCount;
                    if (this.Document.CommonRules.IsFooterRow(sheetId, row) && column > 1) {
                        return SheetFormatCollection.Calc;
                    }
                    else if (row === 0 || row === 1 || row === rowCount - 8) {
                        return SheetFormatCollection.Calc;
                    }
                    else if (row === rowCount - 3) {
                        return SheetFormatCollection.Free;
                    }
                    else {
                        return SheetFormatCollection.Related;
                    }
            }
        };
        InterfaceRules.prototype.SheetP1EditingCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            var rowCount = this.Document.Sheets.getValue(sheetId).RowCount;
            return ((column > 1) && (row === rowCount - 3));
        };
        InterfaceRules.prototype.IsFooterRow = function (sheetId, row) {
            return this.Document.CommonRules.IsFooterRow(sheetId, row, 3);
        };
        InterfaceRules.prototype.SheetP2Sp4FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (column === 1) {
                return undefined;
            }
            else {
                return this.Document.CommonRules.StandardFormat(sheetId, row, column, InterfaceRules._sheetP2Sp4Info);
            }
        };
        InterfaceRules.prototype.SheetP2Sp4CalcEventHandler = function (sheetId, row, column, fieldId) {
            return this.Document.CommonRules.StandardCalc(sheetId, row, column, InterfaceRules._sheetP2Sp4Info);
        };
        InterfaceRules.prototype.SheetP2DailyPayEditingCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            if (column === 1) {
                return false;
            }
            else if (column > 1) {
                var table = this.Document.P2DailyPayDataTable;
                var key = this.Document.Sheets.getValue(sheetId).Table.GetKeyBySourceTable(table);
                return key != null;
            }
        };
        InterfaceRules.prototype.SheetP2DailyPayFormatEventHandler = function (sheetId, row, column, groupIndex) {
            return this.Document.CommonRules.StandardFormat(sheetId, row, column, InterfaceRules._sheetP2DailyPayInfo);
        };
        InterfaceRules.prototype.SheetP2DailyPayCalcEventHandler = function (sheetId, row, column, fieldId) {
            if (BaseObasTableFields.StrCodeField.Equal(fieldId)) {
                var code = row + 11;
                return ObasHelper.FillWithCharacter(code.toString(), 4);
            }
        };
        InterfaceRules.prototype.SheetP3DailyPayCalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.Document.CommonRules.IsFooterRow(sheetId, row)) {
                if (BaseObasTableFields.StrCodeField.Equal(fieldId)) {
                    return 1000;
                }
                else if (column > 1) {
                    if (column === 3 || column === 4 || column === 9 || column === 10) {
                        return ObasHelper.X;
                    }
                    else {
                        var sheet = this.Document.Sheets.getValue(sheetId);
                        return this.Document.CommonRules.GetFooterSum(sheet, row, column);
                    }
                }
                else {
                    if (column === 0) {
                        return InterfaceRules.TotalRowName;
                    }
                }
            }
            else if (BaseObasTableFields.StrCodeField.Equal(fieldId)) {
                return ObasHelper.FillWithCharacter((row + 1).toString(), 4);
            }
            else {
                return this.Document.CommonRules
                    .StandardCalc(sheetId, row, column, InterfaceRules._sheetP3DailyPayInfo);
            }
            return undefined;
        };
        InterfaceRules.prototype.ObjectDescSheetFormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                    return SheetFormatCollection.Related;
                case 2:
                    return SheetFormatCollection.Default;
                case 3:
                case 7:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.ObjectDescSheetCalcEventHandler = function (sheetId, row, column, fieldId) {
            if (BaseObasTableFields.StrCodeField.Equal(fieldId)) {
                return ObasHelper.FillWithCharacter(row + 1, 6);
            }
            return undefined;
        };
        InterfaceRules.prototype.ObjectDescSheetCanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 2;
        };
        InterfaceRules.prototype.ObjectDescSheetCanEditEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column > 2) {
                return table.GetKeyBySourceTable(this._document.P5RefObjDescNpaTable) != null;
            }
            else {
                return false;
            }
        };
        InterfaceRules.prototype.ObjectDescSheetCanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.ObjectDescSheetCanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        InterfaceRules.prototype.FilterKosgu = function () {
            var kosguCodes = ["212", "214", "222", "226", "266", "267"];
            var kosguCode = ObasTableCollection.KosguSprTable.Code.Value;
            return this.Document.CommonRules.FilterKosgu() && (kosguCodes.indexOf(kosguCode) > -1);
        };
        InterfaceRules.prototype.PurchaseObjectsEditorEditFieldEventHandler = function (sheetId, fieldId, newValue, oldValue) {
            var sourceTable = this._document.PurchaseObjectsSprTable;
            switch (fieldId) {
                case sourceTable.Name.Id:
                case sourceTable.NpaGroupKey.Id:
                    var result = 0;
                    var nameObj = sourceTable.Name.Value;
                    var npaGroupKey = sourceTable.NpaGroupKey.Value;
                    while (sourceTable.Locate([sourceTable.Name.Id, sourceTable.NpaGroupKey.Id], [nameObj, npaGroupKey], true)) {
                        result = result + 1;
                    }
                    sourceTable.ClearLocateFlag();
                    this._canAddPurchaseObject = (result === 1);
                    break;
            }
            return true;
        };
        InterfaceRules.prototype.PurchaseObjectsEditorOnCanCloseEventHandler = function (buttonResult) {
            var sourceTable = this._document.PurchaseObjectsSprTable;
            if (buttonResult === MessageResults.Cancel) {
                return true;
            }
            else {
                if (!this._canAddPurchaseObject) {
                    Client.ShowMessage("\u041E\u0448\u0438\u0431\u043A\u0430", "\u0423\u0436\u0435 \u0441\u0443\u0449\u0435\u0441\u0442\u0432\u0443\u0435\u0442 \u043E\u0431\u044A\u0435\u043A\u0442 \u0437\u0430\u043A\u0443\u043F\u043A\u0438 \u0441 \u0442\u0430\u043A\u0438\u043C \u043D\u0430\u0438\u043C\u0435\u043D\u043E\u0432\u0430\u043D\u0438\u0435\u043C \u0438 \u043F\u043E\u0434\u0433\u0440\u0443\u043F\u043F\u043E\u0439 \u043D\u043E\u0440\u043C\u0430\u0442\u0438\u0432\u043D\u044B\u0445 \u0437\u0430\u0442\u0440\u0430\u0442", MessageIcons.Error);
                }
                return (this._canAddPurchaseObject && buttonResult === MessageResults.Ok);
            }
        };
        InterfaceRules.prototype.AfterStartEventHandler = function () {
            ObasTableCollection.NpaSprTable.UpdateDataRows(this._document.P2NpaTable);
            ObasTableCollection.NpaSprTable.UpdateDataRows(this._document.P3NpaTable);
            ObasTableCollection.NpaSprTable.UpdateDataRows(this._document.P5RefObjDescNpaTable);
        };
        InterfaceRules._sheetRowCodeInfo = {
            Column: 1,
            Length: 3,
            LevelIncs: [1],
            CalcTotalCode: function (sheet, row) {
                return 100;
            }
        };
        InterfaceRules._sheetP2Sp4Info = {
            MaxLevel: 1,
            CodeInfo: InterfaceRules._sheetRowCodeInfo,
            ColumnsInfo: [
                InterfaceRules._freeColConstAll,
                SheetColumnInfoCollection.CalcColFormatOnly,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc
            ]
        };
        InterfaceRules._sheetP2DailyPayInfo = {
            MaxLevel: 1,
            ColumnsInfo: [
                InterfaceRules._defaultColConstAll,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.AllDefault,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.CalcColAllCalc
            ]
        };
        return InterfaceRules;
    }(F01400.InterfaceRules));
    F01409.InterfaceRules = InterfaceRules;
    var AnalyticSheet = (function (_super) {
        __extends(AnalyticSheet, _super);
        function AnalyticSheet(id, _document) {
            var _this = _super.call(this, id, false) || this;
            _this._document = _document;
            return _this;
        }
        AnalyticSheet.prototype.IsTotalRow = function (row) {
            return (AnalyticSheet._totalRow.indexOf(row) != -1);
        };
        AnalyticSheet.prototype.IsEditableRow = function (row) {
            return !this.IsTotalRow(row);
        };
        AnalyticSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (column > AnalyticSheet._strCodeColumn) {
                if (this.IsTotalRow(row)) {
                    return SheetFormatCollection.Calc;
                }
                else if (this.IsEditableRow(row)) {
                    return SheetFormatCollection.Free;
                }
                else {
                    return SheetFormatCollection.Related;
                }
            }
            else {
                return SheetFormatCollection.Default;
            }
        };
        AnalyticSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (column > AnalyticSheet._strCodeColumn) {
                if (this.IsTotalRow(row)) {
                    var result = new SheetCalcResult(BaseFormulas.SUM);
                    if (row === 0) {
                        for (var i = row + 1; i < this.RowCount; i++) {
                            if (!this.IsTotalRow(i)) {
                                result.AddCoordinates(new CellCoordinate(i, column));
                            }
                        }
                    }
                    else {
                        var i = row + 1;
                        while (!this.IsTotalRow(i) && i < this.RowCount) {
                            result.AddCoordinates(new CellCoordinate(i, column));
                            i++;
                        }
                    }
                    return result.ToArray();
                }
            }
            return undefined;
        };
        AnalyticSheet.prototype.CanEditCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return ((column > AnalyticSheet._strCodeColumn) && this.IsEditableRow(row));
        };
        AnalyticSheet._strCodeColumn = 1;
        AnalyticSheet._totalRow = [0, 1, 5, 9];
        return AnalyticSheet;
    }(Sheet));
    F01409.AnalyticSheet = AnalyticSheet;
})(F01409 || (F01409 = {}));
