var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F02242;
(function (F02242) {
    var InterfaceRules = (function (_super) {
        __extends(InterfaceRules, _super);
        function InterfaceRules() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        InterfaceRules.prototype.IsRequiredInformAction = function () {
            var exceptFoivCodes = ["089", "184", "187", "189", "202", "302", "303", "304", "305", "308", "330", "333", "415", "417", "436", "437", "438", "587", "721", "724", "730"];
            return exceptFoivCodes.indexOf(ObasTableCollection.SelectedFoivTable.Foiv.Code) === -1;
        };
        InterfaceRules.prototype.LoadDataFromProcurementMenuItemClickEventHandler = function () {
            this.ImportProcurementList();
            if (this._document.ShowEditor("ImportedProcurementListEditor")) {
                this.LoadDataFromProcurement();
            }
            this._document.ImportedProcurementTable.DeleteAllRow();
        };
        InterfaceRules.prototype.LoadDataFromProcurement = function () {
            var okvRubKey = ObasTableCollection.OkvSprTable.RubleKey;
            var procurementId = "Procurement_ID";
            var importedProcurementTable = this._document.ImportedProcurementTable;
            var reader = importedProcurementTable.CreateReader();
            while (reader.Read()) {
                if (importedProcurementTable.IsMarked.Value) {
                    var procurementKBKTable = ObasTableCollection.RroProcurementKBKTable;
                    procurementKBKTable.Locate(procurementKBKTable.RecordKey.Id, importedProcurementTable.ProcurementKBK.ForeignKey.Value);
                    var purchaseObjectsSprTable = this._document.PurchaseObjectsSprTable;
                    if (!purchaseObjectsSprTable.Locate([purchaseObjectsSprTable.Name.Id, procurementId], [procurementKBKTable.ObjectName.Value, procurementKBKTable.ProcurementKey.Value])) {
                        purchaseObjectsSprTable.AddRow();
                        purchaseObjectsSprTable.Name.Value = procurementKBKTable.ObjectName.Value;
                        purchaseObjectsSprTable.SetFieldValue(procurementId, procurementKBKTable.ProcurementKey.Value);
                        purchaseObjectsSprTable.PostRow();
                    }
                    if (!procurementKBKTable.IsForeignProcurement.Value) {
                        var p2sp1RefInfProgTable = this._document.P2sp1RefInfProgTable;
                        if (!p2sp1RefInfProgTable.Locate(procurementId, procurementKBKTable.ProcurementKey.Value)) {
                            p2sp1RefInfProgTable.AddRow();
                            p2sp1RefInfProgTable.SetFieldValue(procurementId, procurementKBKTable.ProcurementKey.Value);
                            p2sp1RefInfProgTable.PostRow();
                        }
                        var p2sp1RefInfActionTable = this._document.P2sp1RefInfActionTable;
                        if (!p2sp1RefInfActionTable.Locate(procurementId, procurementKBKTable.ProcurementKey.Value)) {
                            p2sp1RefInfActionTable.AddRow();
                            p2sp1RefInfActionTable.OwnerKey.Value = p2sp1RefInfProgTable.RecordKey.Value;
                            p2sp1RefInfActionTable.SetFieldValue(procurementId, procurementKBKTable.ProcurementKey.Value);
                            p2sp1RefInfActionTable.PostRow();
                        }
                        var p2sp1RefObjTable = this._document.P2sp1RefObjTable;
                        if (!p2sp1RefObjTable.Locate(p2sp1RefObjTable.ObjectKey.Id, purchaseObjectsSprTable.RecordKey.Value)) {
                            p2sp1RefObjTable.AddRow();
                            p2sp1RefObjTable.OwnerKey.Value = p2sp1RefInfActionTable.RecordKey.Value;
                            p2sp1RefObjTable.ObjectKey.Value = purchaseObjectsSprTable.RecordKey.Value;
                            p2sp1RefObjTable.Okpd.ForeignKey.Value = procurementKBKTable.OKPDKey.Value;
                            p2sp1RefObjTable.PostRow();
                        }
                        var p2sp1RefKosguTable = this._document.P2sp1RefKosguTable;
                        p2sp1RefKosguTable.AddRow();
                        p2sp1RefKosguTable.OwnerKey.Value = p2sp1RefObjTable.RecordKey.Value;
                        p2sp1RefKosguTable.Year.Value = procurementKBKTable.GetProcurementPlacementYear();
                        p2sp1RefKosguTable.PostRow();
                        for (var i = 0; i <= ObasStageSettings.YearsCount - 1; i++) {
                            var fieldId = "Y" + (i + 1);
                            p2sp1RefKosguTable.SetFieldValue(F02110.ObasTableFields.FnYearField.GenerateId(fieldId), procurementKBKTable.GetFieldValue(fieldId));
                        }
                    }
                    else {
                        var p2UniqueOrgs = this._document.P2UniqueOrgs;
                        if (!p2UniqueOrgs.Locate(procurementId, procurementKBKTable.ProcurementKey.Value)) {
                            p2UniqueOrgs.AddRow();
                            p2UniqueOrgs.SetFieldValue(procurementId, procurementKBKTable.ProcurementKey.Value);
                            p2UniqueOrgs.PostRow();
                        }
                        var p2sp2RefInfProgTable = this._document.P2sp2RefInfProgTable;
                        if (!p2sp2RefInfProgTable.Locate(procurementId, procurementKBKTable.ProcurementKey.Value)) {
                            p2sp2RefInfProgTable.AddRow();
                            p2sp2RefInfProgTable.OwnerKey.Value = p2UniqueOrgs.RecordKey.Value;
                            p2sp2RefInfProgTable.SetFieldValue(procurementId, procurementKBKTable.ProcurementKey.Value);
                            p2sp2RefInfProgTable.PostRow();
                        }
                        var p2sp2RefInfActionTable = this._document.P2sp2RefInfActionTable;
                        if (!p2sp2RefInfActionTable.Locate(procurementId, procurementKBKTable.ProcurementKey.Value)) {
                            p2sp2RefInfActionTable.AddRow();
                            p2sp2RefInfActionTable.OwnerKey.Value = p2sp2RefInfProgTable.RecordKey.Value;
                            p2sp2RefInfActionTable.SetFieldValue(procurementId, procurementKBKTable.ProcurementKey.Value);
                            p2sp2RefInfActionTable.PostRow();
                        }
                        var p2sp2RefObjTable = this._document.P2sp2RefObjTable;
                        if (!p2sp2RefObjTable.Locate(p2sp2RefObjTable.ObjectKey.Id, purchaseObjectsSprTable.RecordKey.Value)) {
                            p2sp2RefObjTable.AddRow();
                            p2sp2RefObjTable.OwnerKey.Value = p2sp2RefInfActionTable.RecordKey.Value;
                            p2sp2RefObjTable.ObjectKey.Value = purchaseObjectsSprTable.RecordKey.Value;
                            p2sp2RefObjTable.Okpd.ForeignKey.Value = procurementKBKTable.OKPDKey.Value;
                            p2sp2RefObjTable.PostRow();
                        }
                        var p2sp2RefKosguTable = this._document.P2sp2RefKosguTable;
                        p2sp2RefKosguTable.AddRow();
                        p2sp2RefKosguTable.OwnerKey.Value = p2sp2RefObjTable.RecordKey.Value;
                        p2sp2RefKosguTable.Year.Value = procurementKBKTable.GetProcurementPlacementYear();
                        p2sp2RefKosguTable.PostRow();
                        if (okvRubKey === procurementKBKTable.OKVKey.Value) {
                            for (var i = 0; i <= ObasStageSettings.YearsCount - 1; i++) {
                                var fieldId = "Y" + (i + 1);
                                p2sp2RefKosguTable.SetFieldValue(F02110.ObasTableFields.FnOtherRubField.GenerateId(fieldId), procurementKBKTable.GetFieldValue(fieldId));
                            }
                        }
                        else {
                            for (var i = 0; i <= ObasStageSettings.YearsCount - 1; i++) {
                                var fieldId = "Usd_Y" + (i + 1);
                                p2sp2RefKosguTable.SetFieldValue(F02110.ObasTableFields.FnUsdField.GenerateId(fieldId), procurementKBKTable.GetFieldValue(fieldId));
                            }
                        }
                    }
                }
            }
        };
        return InterfaceRules;
    }(F02110.InterfaceRules));
    F02242.InterfaceRules = InterfaceRules;
    var BaseHierarchySheet = (function (_super) {
        __extends(BaseHierarchySheet, _super);
        function BaseHierarchySheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BaseHierarchySheet.prototype.EditCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 0;
        };
        BaseHierarchySheet._totalRowName = "\u0412\u0441\u0435\u0433\u043E";
        BaseHierarchySheet._totalInfProgRowName = "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043C\u0435\u0440\u043E\u043F\u0440\u0438\u044F\u0442\u0438\u044E \u043F\u0440\u043E\u0433\u0440\u0430\u043C\u043C\u044B";
        BaseHierarchySheet._totalInfActionRowName = "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043C\u0435\u0440\u043E\u043F\u0440\u0438\u044F\u0442\u0438\u044E \u043F\u043E \u0438\u043D\u0444\u043E\u0440\u043C\u0430\u0442\u0438\u0437\u0430\u0446\u0438\u0438";
        BaseHierarchySheet._totalRowInfo = {
            IsCalculated: false,
            Name: BaseHierarchySheet._totalRowName,
            Format: SheetFormatCollection.Default
        };
        BaseHierarchySheet._totalInfActionRowInfo = {
            IsCalculated: false,
            Name: BaseHierarchySheet._totalInfActionRowName,
            Format: SheetFormatCollection.Default
        };
        BaseHierarchySheet._totalInfProgRowInfo = {
            IsCalculated: false,
            Name: BaseHierarchySheet._totalInfProgRowName,
            Format: SheetFormatCollection.Default
        };
        BaseHierarchySheet._subTotalRowInfos = [
            BaseHierarchySheet._totalInfProgRowInfo, BaseHierarchySheet._totalInfActionRowInfo, ""
        ];
        BaseHierarchySheet.SprDefaultTotalFirstSubtotal = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.SprOnlyFormatRow],
            TotalRow: SheetRowInfoCollection.Default
        };
        BaseHierarchySheet.RelatedDefaultTotalFirstSubtotal = {
            Cell: { Type: SheetCellTypes.Related },
            SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.SprOnlyFormatRow],
            TotalRow: SheetRowInfoCollection.Default
        };
        BaseHierarchySheet.SprColConstAll = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: BaseHierarchySheet._subTotalRowInfos,
            TotalRow: BaseHierarchySheet._totalRowInfo
        };
        BaseHierarchySheet.RelatedColConstAll = {
            Cell: { Type: SheetCellTypes.Related },
            SubTotalRow: BaseHierarchySheet._subTotalRowInfos,
            TotalRow: BaseHierarchySheet._totalRowInfo
        };
        BaseHierarchySheet.FreeColConstAll = {
            Cell: { Type: SheetCellTypes.Free },
            SubTotalRow: BaseHierarchySheet._subTotalRowInfos,
            TotalRow: BaseHierarchySheet._totalRowInfo
        };
        BaseHierarchySheet.DefaultColConstAll = {
            Cell: { Type: SheetCellTypes.Default },
            SubTotalRow: BaseHierarchySheet._subTotalRowInfos,
            TotalRow: BaseHierarchySheet._totalRowInfo
        };
        return BaseHierarchySheet;
    }(HierarchyYearGroupSheet));
    F02242.BaseHierarchySheet = BaseHierarchySheet;
    var PurchaseObjectHierarchySheet = (function (_super) {
        __extends(PurchaseObjectHierarchySheet, _super);
        function PurchaseObjectHierarchySheet(document) {
            return _super.call(this, document, 11) || this;
        }
        Object.defineProperty(PurchaseObjectHierarchySheet.prototype, "SheetInfo", {
            get: function () {
                return PurchaseObjectHierarchySheet._sheetInfo;
            },
            enumerable: true,
            configurable: true
        });
        PurchaseObjectHierarchySheet.prototype.GetYearsSumCaptionEventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            return this.Document.CommonRules.CalcColumnCaption(index, 15, 2);
        };
        PurchaseObjectHierarchySheet._CodeInfo = {
            Column: 10,
            Length: 6,
            LevelIncs: [10000, 1000, 1],
            CalcTotalCode: function () {
                return 900000;
            }
        };
        PurchaseObjectHierarchySheet._sheetInfo = {
            MaxLevel: 3,
            CodeInfo: PurchaseObjectHierarchySheet._CodeInfo,
            ColumnsInfo: [
                SheetColumnInfoCollection.SprColDefaultTotal,
                PurchaseObjectHierarchySheet.SprDefaultTotalFirstSubtotal,
                PurchaseObjectHierarchySheet.SprDefaultTotalFirstSubtotal,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                PurchaseObjectHierarchySheet.FreeColConstAll,
                PurchaseObjectHierarchySheet.DefaultColConstAll,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc
            ]
        };
        return PurchaseObjectHierarchySheet;
    }(BaseHierarchySheet));
    F02242.PurchaseObjectHierarchySheet = PurchaseObjectHierarchySheet;
    var BaseHierarchySheet2 = (function (_super) {
        __extends(BaseHierarchySheet2, _super);
        function BaseHierarchySheet2() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BaseHierarchySheet2.prototype.EditCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 0;
        };
        BaseHierarchySheet2._totalRowName = "\u0412\u0441\u0435\u0433\u043E";
        BaseHierarchySheet2._totalOrgRowName = "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u0441\u0442\u0440\u0430\u043D\u0435";
        BaseHierarchySheet2._totalInfProgRowName = "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043C\u0435\u0440\u043E\u043F\u0440\u0438\u044F\u0442\u0438\u044E \u043F\u0440\u043E\u0433\u0440\u0430\u043C\u043C\u044B";
        BaseHierarchySheet2._totalInfActionRowName = "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043C\u0435\u0440\u043E\u043F\u0440\u0438\u044F\u0442\u0438\u044E \u043F\u043E \u0438\u043D\u0444\u043E\u0440\u043C\u0430\u0442\u0438\u0437\u0430\u0446\u0438\u0438";
        BaseHierarchySheet2._totalRowInfo = {
            IsCalculated: false,
            Name: BaseHierarchySheet2._totalRowName,
            Format: SheetFormatCollection.Default
        };
        BaseHierarchySheet2._totalOrgRowInfo = {
            IsCalculated: false,
            Name: BaseHierarchySheet2._totalOrgRowName,
            Format: SheetFormatCollection.Default
        };
        BaseHierarchySheet2._totalInfProgRowInfo = {
            IsCalculated: false,
            Name: BaseHierarchySheet2._totalInfProgRowName,
            Format: SheetFormatCollection.Default
        };
        BaseHierarchySheet2._totalInfActionRowInfo = {
            IsCalculated: false,
            Name: BaseHierarchySheet2._totalInfActionRowName,
            Format: SheetFormatCollection.Default
        };
        BaseHierarchySheet2._subTotalRowInfos = [
            BaseHierarchySheet2._totalOrgRowInfo, BaseHierarchySheet2._totalInfProgRowInfo, BaseHierarchySheet2._totalInfActionRowInfo
        ];
        BaseHierarchySheet2.SprDefaultTotalFirstSubtotal = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.SprOnlyFormatRow, SheetRowInfoCollection.SprOnlyFormatRow],
            TotalRow: SheetRowInfoCollection.Default
        };
        BaseHierarchySheet2.SprDefaultTotalSecondSubtotal = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.Default, SheetRowInfoCollection.SprOnlyFormatRow],
            TotalRow: SheetRowInfoCollection.Default
        };
        BaseHierarchySheet2.SprColConstAll = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: BaseHierarchySheet2._subTotalRowInfos,
            TotalRow: BaseHierarchySheet2._totalRowInfo
        };
        BaseHierarchySheet2.RelatedColConstAll = {
            Cell: { Type: SheetCellTypes.Related },
            SubTotalRow: BaseHierarchySheet2._subTotalRowInfos,
            TotalRow: BaseHierarchySheet2._totalRowInfo
        };
        BaseHierarchySheet2.FreeColConstAll = {
            Cell: { Type: SheetCellTypes.Free },
            SubTotalRow: BaseHierarchySheet2._subTotalRowInfos,
            TotalRow: BaseHierarchySheet2._totalRowInfo
        };
        BaseHierarchySheet2.DefaultColConstAll = {
            Cell: { Type: SheetCellTypes.Default },
            SubTotalRow: BaseHierarchySheet2._subTotalRowInfos,
            TotalRow: BaseHierarchySheet2._totalRowInfo
        };
        return BaseHierarchySheet2;
    }(HierarchyYearGroupSheet));
    F02242.BaseHierarchySheet2 = BaseHierarchySheet2;
    var PurchaseObjectUsdHierarchySheet = (function (_super) {
        __extends(PurchaseObjectUsdHierarchySheet, _super);
        function PurchaseObjectUsdHierarchySheet(document) {
            return _super.call(this, document, 12) || this;
        }
        Object.defineProperty(PurchaseObjectUsdHierarchySheet.prototype, "SheetInfo", {
            get: function () {
                return PurchaseObjectUsdHierarchySheet._sheetInfo;
            },
            enumerable: true,
            configurable: true
        });
        PurchaseObjectUsdHierarchySheet.prototype.GetYearsSumUsdCaptionEventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            return this.Document.CommonRules.CalcColumnCaption(index, 17, 2);
        };
        PurchaseObjectUsdHierarchySheet.prototype.GetYearsSumRubCaptionEventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            return this.Document.CommonRules.CalcColumnCaption(index, 26, 2);
        };
        PurchaseObjectUsdHierarchySheet.prototype.GetYearsSumOtherRubCaptionEventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            return this.Document.CommonRules.CalcColumnCaption(index, 35, 2);
        };
        PurchaseObjectUsdHierarchySheet.prototype.GetYearsTotalSumUsdCaptionEventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            return this.Document.CommonRules.CalcColumnCaption(index, 44, 2);
        };
        PurchaseObjectUsdHierarchySheet._CodeInfo = {
            Column: 12,
            Length: 7,
            LevelIncs: [100000, 10000, 1000, 1],
            CalcTotalCode: function () {
                return 9000000;
            }
        };
        PurchaseObjectUsdHierarchySheet._sheetInfo = {
            MaxLevel: 4,
            CodeInfo: PurchaseObjectUsdHierarchySheet._CodeInfo,
            ColumnsInfo: [
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                PurchaseObjectUsdHierarchySheet.SprDefaultTotalFirstSubtotal,
                PurchaseObjectUsdHierarchySheet.SprDefaultTotalSecondSubtotal,
                PurchaseObjectUsdHierarchySheet.SprDefaultTotalSecondSubtotal,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                PurchaseObjectUsdHierarchySheet.FreeColConstAll,
                PurchaseObjectUsdHierarchySheet.DefaultColConstAll,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc
            ]
        };
        return PurchaseObjectUsdHierarchySheet;
    }(BaseHierarchySheet2));
    F02242.PurchaseObjectUsdHierarchySheet = PurchaseObjectUsdHierarchySheet;
})(F02242 || (F02242 = {}));
