var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F03400;
(function (F03400) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP2Data("\u0421\u0442\u0438\u043F\u0435\u043D\u0434\u0438\u0438"));
            result.push(this.GetAnalyticRespredelenieData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041E\u0411\u0410\u0421"));
            result.push(this.GetP3NpaData("\u041D\u041F\u0410"));
            result.push(this.GetP2DetailData("\u0424\u0430\u043A\u0442\u043E\u0440\u044B\u0420\u0430\u0441\u0447\u0435\u0442\u0430"));
            result.push(this.GetP1Data("\u041E\u0411\u0410\u0421"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            return result;
        };
        ExportRules.prototype.GenYearData = function (srcTable, fieldId, startIndex) {
            var result = "";
            for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                result += "b" + (startIndex + j) + "=\"" + (srcTable.GetFieldValue(fieldId + j.toString()) || 0) + "\" ";
            }
            return result;
        };
        ExportRules.prototype.GetP1Data = function (barsTableId) {
            var srcTable = this._document.P1TotalTable;
            var P1StrKeys = F03400.P1StrKeys;
            var keys = [P1StrKeys.Obas, P1StrKeys.AddObas, P1StrKeys.Total, 100];
            var strCodes = ["01", "02", "03", "100"];
            var yearsCount = ObasStageSettings.YearsCount;
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template = "<a ID=\"" + strCodes[i] + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    for (var j = 0; j < yearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                }
                else {
                    template += "b3=\"0\" b4=\"0\" b5=\"0\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Data = function (barsTableId) {
            var dataTable = this._document.P2RecipientsTable;
            var srcTable = this._document.P2RecipientsTransTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                dataTable.Locate(dataTable.Grant.ForeignKey.Id, srcTable.GetFieldValue(dataTable.Grant.ForeignKey.Id));
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((dataTable.Grant.Name || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.Count.Id, 3);
                template += this.GenYearData(srcTable, dataTable.Obas.Id, 7);
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2DetailData = function (barsTableId) {
            var dataTable = this._document.P2RecipientsTable;
            var srcTable = this._document.P2RecipientsTransTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                dataTable.Locate([dataTable.Grant.ForeignKey.Id, dataTable.Recipient.ForeignKey.Id], [srcTable.GetFieldValue(dataTable.Grant.ForeignKey.Id), srcTable.GetFieldValue(dataTable.Recipient.ForeignKey.Id)]);
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((dataTable.Grant.Name || "")) + "\" ";
                template += "b2=\"" + ((dataTable.Recipient.Name || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.Count.Id, 4);
                template += this.GenYearData(srcTable, dataTable.Pay.Id, 8);
                template += this.GenYearData(srcTable, dataTable.Obas.Id, 12);
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3NpaData = function (barsTableId) {
            var srcTable = this._document.TableP3Npa;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.Grant.Name || "") + "\" ";
                template += "b2=\"" + (srcTable.Recipient.Name || "") + "\" ";
                template += "b7=\"" + ((srcTable.NpaStatus.Code === "1") ? "true" : "fasle") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaName.Value || "") + "\" ";
                template += "b8=\"" + (srcTable.NpaType.Code || "") + "\" ";
                template += "b9=\"" + (ObasHelper.ConvertToString(srcTable.NpaDate.Value) || "") + "\" ";
                template += "b10=\"" + (srcTable.NpaNumber.Value || "") + "\" ";
                template += "bstate=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "bDateChanState=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 0; i < kosguData.length; i++) {
                var template = "<a ID=\"" + ((kosguData[i].Code === "-") ? "200" : kosguData[i].Code) + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticRespredelenieData = function (barsTableId) {
            var srcData = [];
            srcData.push("<a ID=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" barservice=\"\u0412\u0441\u0435\u0433\u043E, \u0438\u0437 \u043D\u0438\u0445:\" />");
            srcData.push("<a ID=\"1\" b4=\"0\" b5=\"0\" b6=\"0\" barservice=\"\u041D\u0435\u0440\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u043D\u044B\u0439 \u043E\u0441\u0442\u0430\u0442\u043E\u043A\" />");
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (barsTableId) {
            var strCodes = ["290", "total"];
            var srcData = [];
            for (var i = 0; i < strCodes.length; i++) {
                if (strCodes[i] === "total") {
                    srcData.push("<a ID=\"" + strCodes[i] + "\" b4=\"0\" b5=\"0\" b6=\"0\" />");
                }
                else {
                    srcData.push("<a ID=\"" + strCodes[i] + "\" b1=\"" + strCodes[i] + "\" b2=\"" + strCodes[i] + "\" b4=\"0\" b5=\"0\" b6=\"0\" />");
                }
            }
            return { Id: barsTableId, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F03400.ExportRules = ExportRules;
})(F03400 || (F03400 = {}));
