var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F03500;
(function (F03500) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP1Data("\u041E\u0411\u0410\u0421"));
            result.push(this.GetP2Data("\u0424\u0430\u043A\u0442\u043E\u0440\u044B\u0420\u0430\u0441\u0447\u0435\u0442\u0430"));
            result.push(this.GetP3NpaData("\u041D\u041F\u0410"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            result.push(this.GetAnalyticRespredelenieData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041E\u0411\u0410\u0421"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423"));
            return result;
        };
        ExportRules.prototype.GenYearData = function (srcTable, fieldId, startIndex) {
            var result = "";
            for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                result += "b" + (startIndex + j) + "=\"" + (srcTable.GetFieldValue(fieldId + j.toString()) || 0) + "\" ";
            }
            return result;
        };
        ExportRules.prototype.GetP1Data = function (barsTableId) {
            var srcTable = this._document.P1TotalTable;
            var keys = [1, 100];
            var strCodes = ["01", "100"];
            var yearsCount = ObasStageSettings.YearsCount;
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template = "<a ID=\"" + strCodes[i] + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    for (var j = 0; j < yearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                }
                else {
                    template += "b3=\"0\" b4=\"0\" b5=\"0\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Data = function (barsTableId) {
            var dataTable = this._document.P2DataTable;
            var srcTable = this._document.P2DataTransTable;
            var keys = [1, 2, 3, 4];
            var strCodes = ["01", "02", "03", "04"];
            var yearsCount = ObasStageSettings.YearsCount;
            var srcDataArr = new Array(yearsCount);
            var emptyTotalStr = "b3=\"0\" b4=\"0\" b5=\"0\" b7=\"0\" b8=\"0\" b9=\"0\" b11=\"0\" b12=\"0\" b13=\"0\" b15=\"0\" b16=\"0\" b17=\"0\" b19=\"0\" b20=\"0\" b21=\"0\" ";
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template_1 = "<a ID=\"" + strCodes[i] + "\" ";
                if (srcTable.Locate(dataTable.StrKeyField.Id, keys[i])) {
                    template_1 += this.GenYearData(srcTable, dataTable.Count.Id, 3);
                    template_1 += this.GenYearData(srcTable, dataTable.Pay.Id, 7);
                    template_1 += this.GenYearData(srcTable, dataTable.MonthCount.Id, 11);
                    template_1 += this.GenYearData(srcTable, dataTable.YearCount.Id, 15);
                    template_1 += this.GenYearData(srcTable, dataTable.Refund.Id, 19);
                    template_1 += this.GenYearData(srcTable, dataTable.Obas.Id, 23);
                    for (var j = 0; j < yearsCount; j++) {
                        srcDataArr[j] = (srcDataArr[j] || 0) + (srcTable.GetFieldValue(dataTable.Obas.Id + j.toString()) || 0);
                    }
                }
                else {
                    template_1 += emptyTotalStr + "b23=\"0\" b24=\"0\" b25=\"0\" ";
                }
                template_1 += "/>";
                srcData.push(template_1);
            }
            var template = "<a ID=\"05\" " + emptyTotalStr;
            for (var j = 0; j < yearsCount; j++) {
                template += "b" + (23 + j) + "=\"" + (srcDataArr[j] || 0) + "\" ";
            }
            template += "/>";
            srcData.push(template);
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3NpaData = function (barsTableId) {
            var srcTable = this._document.TableP3Npa;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b5=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b6=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b7=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "bDateChanState=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "b8=\"" + (srcTable.OwnerKey.SourceTable.Name.Value || "") + "\" ";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticRespredelenieData = function (barsTableId) {
            var srcData = [];
            srcData.push("<a ID=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" barservice=\"\u0412\u0441\u0435\u0433\u043E, \u0438\u0437 \u043D\u0438\u0445:\" />");
            srcData.push("<a ID=\"1\" b4=\"0\" b5=\"0\" b6=\"0\" barservice=\"\u041D\u0435\u0440\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u043D\u044B\u0439 \u043E\u0441\u0442\u0430\u0442\u043E\u043A\" />");
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 0; i < kosguData.length; i++) {
                var template = "<a ID=\"" + ((kosguData[i].Code === "-") ? "200" : kosguData[i].Code) + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (id) {
            var strCodes = ["221", "222", "226", "262", "290", "total"];
            var srcData = [];
            for (var i = 0; i < strCodes.length; i++) {
                srcData.push("<a ID=\"" + strCodes[i] + "\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            }
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F03500.ExportRules = ExportRules;
})(F03500 || (F03500 = {}));
