var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F08100;
(function (F08100) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP1Data("\u0418\u0422\u041E\u0413\u0418"));
            result.push(this.GetP2Sp1Data("\u0424\u0430\u043A\u0442\u043E\u0440\u044B_1"));
            result.push(this.GetP2Sp1DetailData("\u0420\u0430\u0441\u0447\u0435\u0442_1"));
            result.push(this.GetP2NpaData("\u041D\u041F\u0410_1"));
            result.push(this.GetP3Sp1Data("\u0424\u0430\u043A\u0442\u043E\u0440\u044B_2"));
            result.push(this.GetP3Sp1DetailData("\u0420\u0430\u0441\u0447\u0435\u0442_2"));
            result.push(this.GetP3NpaData("\u041D\u041F\u0410_2"));
            result.push(this.GetP4Sp1Data("\u0424\u0430\u043A\u0442\u043E\u0440\u044B_3"));
            result.push(this.GetP4Sp1DetailData("\u0420\u0430\u0441\u0447\u0435\u0442_3"));
            result.push(this.GetP4NpaData("\u041D\u041F\u0410_3"));
            result.push(this.GetP5Sp1Data("\u0424\u0430\u043A\u0442\u043E\u0440\u044B_4"));
            result.push(this.GetP5NpaData("\u041D\u041F\u0410_4"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            result.push(this.GetAnalyticRespredelenieData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041E\u0411\u0410\u0421"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423"));
            return result;
        };
        ExportRules.prototype.GenYearData = function (srcTable, fieldId, startIndex) {
            var result = "";
            for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                result += "b" + (startIndex + j) + "=\"" + (srcTable.GetFieldValue(fieldId + j.toString()) || 0) + "\" ";
            }
            return result;
        };
        ExportRules.prototype.GetP1Data = function (barsTableId) {
            var srcTable = this._document.TableP1;
            var P1StrKeys = F08100.StrKeysP1Total;
            var keys = [P1StrKeys.Total, P1StrKeys.P2, P1StrKeys.P3, P1StrKeys.P4, P1StrKeys.P5, 100];
            var strCodes = ["01", "02", "03", "04", "05", "100"];
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template = "<a ID=\"" + strCodes[i] + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                }
                else {
                    template += "b3=\"0\" b4=\"0\" b5=\"0\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp1Data = function (barsTableId) {
            var dataTable = this._document.TableP2;
            var srcTable = this._document.TransTableP2;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                dataTable.Locate([dataTable.Subsidie.ForeignKey.Id, dataTable.Okpd.ForeignKey.Id, dataTable.Okei.ForeignKey.Id,
                    dataTable.PersonName.Id], [srcTable.GetFieldValue(dataTable.Subsidie.ForeignKey.Id), srcTable.GetFieldValue(dataTable.Okpd.ForeignKey.Id),
                    srcTable.GetFieldValue(dataTable.Okei.ForeignKey.Id), srcTable.GetFieldValue(dataTable.PersonName.Id)]);
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((dataTable.Subsidie.Code || "")) + "\" ";
                template += "b2=\"" + ((dataTable.PersonName.Value || "")) + "\" ";
                template += "b3=\"" + ((dataTable.Okpd.Code || "")) + "\" ";
                template += "b3_clone=\"" + ((dataTable.Okpd.Code || "")) + "\" ";
                template += "b4=\"" + ((dataTable.Okpd.Name || "")) + "\" ";
                template += "b5=\"" + ((dataTable.Okei.Code || "")) + "\" ";
                template += "b6=\"" + ((dataTable.Okei.Name || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.TotalPrice.Id, 8);
                template += this.GenYearData(srcTable, dataTable.BudgetSum.Id, 12);
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp1DetailData = function (barsTableId) {
            var srcTable = this._document.TableP2;
            var transTable = this._document.TransTableP2;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((srcTable.Year.Value || 0)) + "\" ";
                template += "b2=\"" + ((srcTable.UnitCount.Value || 0)) + "\" ";
                template += "b3=\"" + ((srcTable.Price.Value || 0)) + "\" ";
                template += "b4=\"" + ((srcTable.SubsPrice.Value || 0)) + "\" ";
                template += "b5=\"" + ((srcTable.TotalPrice.Value || 0)) + "\" ";
                template += "b6=\"" + ((srcTable.BudgetSum.Value || 0)) + "\" ";
                transTable.Locate([srcTable.Subsidie.ForeignKey.Id, srcTable.Okpd.ForeignKey.Id, srcTable.Okei.ForeignKey.Id, srcTable.PersonName.Id], [srcTable.Subsidie.ForeignKey.Value, srcTable.Okpd.ForeignKey.Value, srcTable.Okei.ForeignKey.Value, srcTable.PersonName.Value]);
                template += "bFILTERINGCOLUMN=\"" + (transTable.RecordKey.Value) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2NpaData = function (barsTableId) {
            var srcTable = this._document.TableP2Npa;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((srcTable.Subsidie.Name || "")) + "\" ";
                template += "b\u043F\u0440\u0438\u0437\u043D\u0430\u043A\u041F\u0440\u043E\u0435\u043A\u0442\u0430=\"False\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "b8=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b9=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b10=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b11=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "b12=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3Sp1Data = function (barsTableId) {
            var dataTable = this._document.TableP3;
            var srcTable = this._document.TransTableP3;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                dataTable.Locate(dataTable.AgrcMachinery.ForeignKey.Id, srcTable.GetFieldValue(dataTable.AgrcMachinery.ForeignKey.Id));
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((dataTable.AgrcMachinery.Code || "")) + "\" ";
                template += "b1_clone=\"" + ((dataTable.AgrcMachinery.Code || "")) + "\" ";
                template += "b2=\"" + ((dataTable.AgrcMachinery.Name || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.TotalPrice.Id, 6);
                template += this.GenYearData(srcTable, dataTable.BudgetSum.Id, 10);
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3Sp1DetailData = function (barsTableId) {
            var srcTable = this._document.TableP3;
            var transTable = this._document.TransTableP3;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((srcTable.Year.Value || 0)) + "\" ";
                template += "b2=\"" + ((srcTable.UnitCount.Value || 0)) + "\" ";
                template += "b3=\"" + ((srcTable.Price.Value || 0)) + "\" ";
                template += "b4=\"" + ((srcTable.SubsPrice.Value || 0)) + "\" ";
                template += "b5=\"" + ((srcTable.TotalPrice.Value || 0)) + "\" ";
                template += "b6=\"" + ((srcTable.BudgetSum.Value || 0)) + "\" ";
                transTable.Locate(srcTable.AgrcMachinery.ForeignKey.Id, srcTable.AgrcMachinery.ForeignKey.Value);
                template += "bFILTERINGCOLUMN=\"" + (transTable.RecordKey.Value) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3NpaData = function (barsTableId) {
            var srcTable = this._document.TableP3Npa;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b\u043F\u0440\u0438\u0437\u043D\u0430\u043A\u041F\u0440\u043E\u0435\u043A\u0442\u0430=\"False\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "b7=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b8=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b10=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b11=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "b12=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP4Sp1Data = function (barsTableId) {
            var dataTable = this._document.TableP4;
            var srcTable = this._document.TransTableP4;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                dataTable.Locate([dataTable.OwnerKey.Id, dataTable.TargetSubsidiesSprTable.ForeignKey.Id], [srcTable.GetFieldValue(dataTable.OwnerKey.Id), srcTable.GetFieldValue(dataTable.TargetSubsidiesSprTable.ForeignKey.Id)]);
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((dataTable.OwnerKey.SourceTable.Csr.Name || "")) + "\" ";
                template += "b2=\"" + ((dataTable.TargetSubsidiesSprTable.Name || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.BudgetSum.Id, 4);
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP4Sp1DetailData = function (barsTableId) {
            var srcTable = this._document.TableP4;
            var transTable = this._document.TransTableP4;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((srcTable.Year.Value || 0)) + "\" ";
                template += "b2=\"" + ((srcTable.CreditSum.Value || 0)) + "\" ";
                template += "b3=\"" + ((srcTable.SsudaDolg.Value || 0)) + "\" ";
                template += "b4=\"" + ((srcTable.CreditPeriod.Value || 0)) + "\" ";
                template += "b5=\"" + ((srcTable.MonthCount.Value || 0)) + "\" ";
                template += "b6=\"" + ((srcTable.InterestRate.Value || 0)) + "\" ";
                template += "b7=\"" + ((srcTable.RecoverRate.Value || 0)) + "\" ";
                template += "b8=\"" + ((srcTable.BudgetSum.Value || 0)) + "\" ";
                transTable.Locate([srcTable.OwnerKey.Id, srcTable.TargetSubsidiesSprTable.ForeignKey.Id], [srcTable.OwnerKey.Value, srcTable.TargetSubsidiesSprTable.ForeignKey.Value]);
                template += "bFILTERINGCOLUMN=\"" + (transTable.RecordKey.Value) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP4NpaData = function (barsTableId) {
            var srcTable = this._document.TableP4Npa;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((this._document.MainParametersTable.Csr.Name || "")) + "\" ";
                template += "b2=\"" + ((srcTable.TargetSubsidie.Name || "")) + "\" ";
                template += "b\u043F\u0440\u0438\u0437\u043D\u0430\u043A\u041F\u0440\u043E\u0435\u043A\u0442\u0430=\"False\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "b9=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b10=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b11=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b12=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "b13=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP5Sp1Data = function (barsTableId) {
            var srcTable = this._document.TableP5;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((srcTable.Subsidie.Value || "")) + "\" ";
                template += "b2=\"" + ((srcTable.PersonName.Value || "")) + "\" ";
                for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                    template += "b" + (4 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP5NpaData = function (barsTableId) {
            var srcTable = this._document.TableP5Npa;
            var parentTable = this._document.TableP5;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var isExistKey = parentTable.Locate(parentTable.RecordKey.Id, srcTable.GetFieldValue("OwnerKey"));
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((isExistKey ? (parentTable.Subsidie.Value || "") : "")) + "\" ";
                template += "b2=\"" + ((isExistKey ? (parentTable.PersonName.Value || "") : "")) + "\" ";
                template += "b\u043F\u0440\u0438\u0437\u043D\u0430\u043A\u041F\u0440\u043E\u0435\u043A\u0442\u0430=\"False\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "b9=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b10=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b11=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b12=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "b13=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticRespredelenieData = function (barsTableId) {
            var srcData = [];
            srcData.push("<a ID=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" barservice=\"\u0412\u0441\u0435\u0433\u043E, \u0438\u0437 \u043D\u0438\u0445:\" />");
            srcData.push("<a ID=\"1\" b4=\"0\" b5=\"0\" b6=\"0\" barservice=\"\u041D\u0435\u0440\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u043D\u044B\u0439 \u043E\u0441\u0442\u0430\u0442\u043E\u043A\" />");
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var kosguTable = ObasTableCollection.KosguSprTable;
            var srcData = [];
            for (var i = 1; i < kosguData.length; i++) {
                var template = "<a ID=\"" + (i - 1) + "\" ";
                template += "b1=\"" + (!kosguTable.Locate(kosguTable.Code.Id, kosguData[i].Code) ? "" : (kosguTable.Name.Value || "")) + "\" ";
                template += "b2=\"" + (kosguData[i].Code || "") + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (id) {
            var strCodes = ["241", "242", "530", "total"];
            var srcData = [];
            for (var i = 0; i < strCodes.length; i++) {
                srcData.push("<a ID=\"" + strCodes[i] + "\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            }
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F08100.ExportRules = ExportRules;
})(F08100 || (F08100 = {}));
