var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F08810;
(function (F08810) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP1Data("\u0418\u0422\u041E\u0413\u0418"));
            result.push(this.GetAnalyticRespredelenieData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435 \u0440\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435 \u041E\u0411\u0410\u0421"));
            result.push(this.GetP2Data("\u0418\u043C\u0443\u0449\u0435\u0441\u0442\u0432\u043E"));
            result.push(this.GetP2Sp1Data("\u0418\u043C\u0443\u0449\u0435\u0441\u0442\u0432\u043E\u0420\u0430\u0441\u0447\u0435\u0442"));
            result.push(this.GetP3Data("\u0417\u0435\u043C\u043B\u044F"));
            result.push(this.GetP3Sp1Data("\u0417\u0435\u043C\u043B\u044F\u0420\u0430\u0441\u0447\u0435\u0442"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            return result;
        };
        ExportRules.prototype.GetP1Data = function (barsTableId) {
            var srcTable = this._document.TableP1TopSum;
            var strKeys = [1, 2, 100];
            var strCodes = ["01", "02", "100"];
            var srcData = [];
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                if (strKeys.indexOf(srcTable.RecordKey.Value) !== -1) {
                    var template = "<a ID=\"" + strCodes[strKeys.indexOf(srcTable.RecordKey.Value)] + "\" ";
                    for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue("Y" + (j + 1).toString()) || 0) + "\" ";
                    }
                    template += "b6=\"0\" />";
                    srcData.push(template);
                }
            }
            for (var i = 1; i <= ObasStageSettings.YearsCount + 1; i++) {
                srcData.push("<c ID=\"SUM_" + i + "\" />");
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticRespredelenieData = function (barsTableId) {
            var srcData = [];
            srcData.push("<a ID=\"01\" b4=\"0\" b5=\"0\" b6=\"0\" barservice=\"\u0412\u0441\u0435\u0433\u043E, \u0438\u0437 \u043D\u0438\u0445:\" />");
            srcData.push("<a ID=\"02\" b4=\"0\" b5=\"0\" b6=\"0\" barservice=\"\u041D\u0435\u0440\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u043D\u044B\u0439 \u043E\u0441\u0442\u0430\u0442\u043E\u043A\" />");
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Data = function (barsTableId) {
            var srcTable = this._document.TableP2;
            var srcData = [];
            var i = 1;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + ObasHelper.FillWithCharacter(i.toString(), 2) + "\" ";
                template += "b1=\"" + srcTable.OkatoField.Code + "\" ";
                for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                    template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue("Y" + (j + 1).toString()) || 0) + "\" ";
                }
                template += "b6=\"0\" />";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp1Data = function (barsTableId) {
            var sumTable = this._document.TableP2;
            var srcTable = this._document.TableP2Sp1;
            var srcData = [];
            var yearsCount = ObasStageSettings.YearsCount + this._document.AddDataYearsCount;
            var i = 1;
            var reader = sumTable.CreateReader();
            while (reader.Read()) {
                for (var j = 0; j < yearsCount; j++) {
                    var year = ObasStageSettings.CurrentYear + j;
                    var template = "<a ID=\"" + ObasHelper.FillWithCharacter(i.toString(), 2) + "\" ";
                    template += "b1=\"" + year + "\" ";
                    if (srcTable.Locate([srcTable.OkatoField.ForeignKey.Id, srcTable.Year.Id], [sumTable.OkatoField.ForeignKey.Value, year])) {
                        template += "b2=\"" + (srcTable.PropertySumTotal.Value || 0) + "\" ";
                        template += "b3=\"" + (srcTable.PropertySumOther.Value || 0) + "\" ";
                        template += "b4=\"" + (srcTable.PropertyTaxG7.Code || "") + "\" ";
                        template += "b5=\"" + (srcTable.PropertySumBenefit.Value || 0) + "\" ";
                        template += "b6=\"" + (srcTable.TaxBase.Value || 0) + "\" ";
                        template += "b7=\"" + (srcTable.PropertyTaxG10.Code || "") + "\" ";
                        template += "b8=\"" + (srcTable.TaxRate.Value || 0) + "\" ";
                        template += "b9=\"" + (srcTable.TaxSum.Value || 0) + "\" ";
                        template += "b10=\"" + (srcTable.PropertyTaxG13.Code || "") + "\" ";
                        template += "b11=\"" + (srcTable.TaxBenefitSum.Value || 0) + "\" ";
                        template += "b12=\"" + (srcTable.TaxSumOther.Value || 0) + "\" ";
                        template += "b13=\"" + (srcTable.Total.Value || 0) + "\" ";
                    }
                    else {
                        template += "b2=\"0\" b3=\"0\" b4=\"\" b5=\"0\" b6=\"0\" b7=\"\" b8=\"0\" b9=\"0\" b10=\"\" b11=\"0\" b12=\"0\" b13=\"0\" ";
                    }
                    template += "/>";
                    srcData.push(template);
                }
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3Data = function (barsTableId) {
            var srcTable = this._document.TableP3;
            var srcData = [];
            var i = 1;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + ObasHelper.FillWithCharacter(i.toString(), 2) + "\" ";
                template += "b1=\"" + srcTable.OkatoField.Code + "\" ";
                template += "b2=\"" + srcTable.CadastreNumField.Value + "\" ";
                for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                    template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue("Y" + (j + 1).toString()) || 0) + "\" ";
                }
                template += "b6=\"0\" />";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3Sp1Data = function (barsTableId) {
            var sumTable = this._document.TableP3;
            var srcTable = this._document.TableP3Sp1;
            var srcData = [];
            var yearsCount = ObasStageSettings.YearsCount + this._document.AddDataYearsCount;
            var i = 1;
            var reader = sumTable.CreateReader();
            while (reader.Read()) {
                for (var j = 0; j < yearsCount; j++) {
                    var year = ObasStageSettings.CurrentYear + j;
                    var template = "<a ID=\"" + ObasHelper.FillWithCharacter(i.toString(), 2) + "\" ";
                    template += "b1=\"" + year + "\" ";
                    if (srcTable.Locate([srcTable.OkatoField.ForeignKey.Id, srcTable.CadastreNumField.Id, srcTable.Year.Id], [sumTable.OkatoField.ForeignKey.Value, sumTable.CadastreNumField.Value, year])) {
                        template += "b3=\"" + (srcTable.LandCategory.Code || "") + "\" ";
                        template += "b4=\"" + (srcTable.CadastreSum.Value || 0) + "\" ";
                        template += "b5=\"" + (srcTable.TaxpayerSum.Value || 0) + "\" ";
                        template += "b6=\"" + (srcTable.LandTaxG9.Code || "") + "\" ";
                        template += "b7=\"" + (srcTable.PropertySumBenefit.Value || 0) + "\" ";
                        template += "b8=\"" + (srcTable.TaxBase.Value || 0) + "\" ";
                        template += "b9=\"" + (srcTable.TaxRate.Value || 0) + "\" ";
                        template += "b10=\"" + (srcTable.TaxMonthes.Value || 0) + "\" ";
                        template += "b11=\"" + (srcTable.Kv.Value || 0) + "\" ";
                        template += "b12=\"" + (srcTable.TaxSum.Value || 0) + "\" ";
                        template += "b13=\"" + (srcTable.BenefitMonthes.Value || 0) + "\" ";
                        template += "b14=\"" + (srcTable.Kl.Value || 0) + "\" ";
                        template += "b15=\"" + (srcTable.LandTaxG18.Code || "") + "\" ";
                        template += "b16=\"" + (srcTable.TaxBenefitSumG19.Value || 0) + "\" ";
                        template += "b17=\"" + (srcTable.LandTaxG20.Code || "") + "\" ";
                        template += "b18=\"" + (srcTable.TaxBenefitSumG21.Value || 0) + "\" ";
                        template += "b19=\"" + (srcTable.LandTaxG22.Code || "") + "\" ";
                        template += "b20=\"" + (srcTable.TaxBenefitSumG23.Value || 0) + "\" ";
                        template += "b21=\"" + (srcTable.LandTaxG24.Code || "") + "\" ";
                        template += "b22=\"" + (srcTable.TaxBenefitSumG25.Value || 0) + "\" ";
                        template += "b23=\"" + (srcTable.Total.Value || 0) + "\" ";
                        template += "b24=\"" + (sumTable.GetFieldValue("Y" + (j + 1).toString()) || 0) + "\" ";
                    }
                    else {
                        template += "b3=\"\" b4=\"0\" b5=\"0\" b6=\"\" b7=\"0\" b8=\"0\" b9=\"0\" b10=\"0\" b11=\"0\" b12=\"0\" b13=\"0\" b14=\"0\" b15=\"\" b16=\"0\" b17=\"\" b18=\"0\" b19=\"\" b20=\"0\" b21=\"\" b22=\"0\" b23=\"0\" b24=\"0\" ";
                    }
                    template += "/>";
                    srcData.push(template);
                }
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var srcData = [];
            var yearsCount = ObasStageSettings.YearsCount + this._document.AddDataYearsCount;
            for (var i = 0; i < kosguData.length; i++) {
                var template = "<a ID=\"" + ((kosguData[i].Code === "-") ? "200" : kosguData[i].Code) + "\" ";
                for (var j = 1; j < yearsCount + 1; j++) {
                    template += "b" + (2 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F08810.ExportRules = ExportRules;
})(F08810 || (F08810 = {}));
