﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F08821;
(function (F08821) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP1Data("\u041E\u0431\u044A\u0435\u043C\u044B_\u0411\u0410"));
            result.push({ Id: "\u0412\u0430\u043B\u044E\u0442\u0430", Data: [] });
            result.push(this.GetRateDollarData("\u041A\u0443\u0440\u0441"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetAnalyticKosguRemainsData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423_\u041E\u0441\u0442\u0430\u0442\u043E\u043A", kosguData));
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423"));
            return result;
        };
        ExportRules.prototype.GetP1Data = function (barsTableId) {
            var srcTable = this._document.P1Table;
            var P1StrKeys = F08821.P1StrKeys;
            var keys = [P1StrKeys.Str01, -1, P1StrKeys.Str03, -1, -1, P1StrKeys.Str04, P1StrKeys.StrTotal, -1, 100];
            var strCodes = ["010", "020", "030", "040", "050", "060", "070", "080", "100"];
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template = "<a ID=\"" + strCodes[i] + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                }
                else {
                    template += "b3=\"0\" b4=\"0\" b5=\"0\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 0; i < kosguData.length; i++) {
                var template = "<a ID=\"" + ((kosguData[i].Code === "-") ? "200" : kosguData[i].Code) + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "b7=\"0\" b8=\"0\" b9=\"0\" />";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguRemainsData = function (id, kosguData) {
            var srcData = [];
            for (var i = 0; i < kosguData.length; i++) {
                srcData.push("<a ID=\"" + ((kosguData[i].Code === "-") ? "200" : kosguData[i].Code) + "\" b4=\"0\" b11=\"0\" b5=\"0\" b12=\"0\" b6=\"0\" b13=\"0\" b7=\"0\" b8=\"0\" b9=\"0\" />");
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (id) {
            var strCodes = ["290", "total"];
            var srcData = [];
            for (var i = 0; i < strCodes.length; i++) {
                srcData.push("<a ID=\"" + strCodes[i] + "\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            }
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F08821.ExportRules = ExportRules;
})(F08821 || (F08821 = {}));
