var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F10120;
(function (F10120) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP1Data("\u041E\u0411\u0410\u0421"));
            result.push(this.GetP2Sp1Data("\u0420\u0443\u0431"));
            result.push(this.GetPXSp2Data("\u041D\u041F\u0410", this._document.TableP2SbP1));
            result.push(this.GetP3Sp1Data("\u0418\u043D\u043E\u0441\u0442\u0440\u0430\u043D\u043D\u0430\u044F\u0412\u0430\u043B\u044E\u0442\u0430"));
            result.push(this.GetPXSp2Data("\u041D\u041F\u0410\u0418\u0412", this._document.TableP3SbP1));
            result.push(this.GetRateDollarData("\u041A\u0443\u0440\u0441"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423"));
            result.push(this.GetInfoUZData("\u0421\u0432\u0435\u0434\u0435\u043D\u0438\u044F_\u0423\u0417", this._document.P5RefKosguTable));
            result.push(this.GetRationaleUZData("\u041E\u0431\u043E\u0441\u043D\u043E\u0432\u0430\u043D\u0438\u0435_\u0423\u0417"));
            result.push(this.GetNpaUZData("\u041D\u041F\u0410_\u0423\u0417", this._document.P5RefObjDescNpaTable, this._document.P5RefObjTable));
            return result;
        };
        ExportRules.prototype.GetP1Data = function (barsTableId) {
            var srcTable = this._document.TableP1;
            var rowsTable = this._document.TableRowsP1;
            var P1StrKeys = F10120.StrKeysP1Total;
            var keys = [P1StrKeys.Total, P1StrKeys.P2, P1StrKeys.P3, 100];
            var strCodes = ["01", "02", "03", "100"];
            var yearsCount = ObasStageSettings.YearsCount;
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template = "<a ID=\"" + strCodes[i] + "\" ";
                template += "b1=\"" + (rowsTable.Locate(rowsTable.RecordKey.Id, keys[i]) ? rowsTable.Name.Value : "") + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    for (var j = 0; j < yearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                    for (var j = 0; j < yearsCount; j++) {
                        template += "b" + (7 + j) + "=\"" + (srcTable.GetFieldValue(F10120.ObasTableFields.OtherRubField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                }
                else {
                    template += "b3=\"0\" b4=\"0\" b5=\"0\" b7=\"0\" b8=\"0\" b9=\"0\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            for (var i = 1; i <= yearsCount + 1; i++) {
                srcData.push("<c ID=\"SUM_" + i + "\" />");
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp1Data = function (barsTableId) {
            var srcTable = this._document.TableP2SbP1;
            var yearsCount = ObasStageSettings.YearsCount;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((srcTable.Name.Value || "")) + "\" ";
                for (var j = 0; j < yearsCount; j++) {
                    template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                for (var j = 0; j < yearsCount; j++) {
                    template += "b" + (7 + j) + "=\"" + (srcTable.GetFieldValue(F10120.ObasTableFields.OtherRubField.GenerateId(j + 1)) || 0) + "\" ";
                }
                template += "bID=\"" + srcTable.RecordKey.Value + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetPXSp2Data = function (barsTableId, srcTable) {
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((srcTable.Name.Value || "")) + "\" ";
                template += "bID=\"" + srcTable.RecordKey.Value + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "b6=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b7=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b8=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b10=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "b11=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3Sp1Data = function (barsTableId) {
            var srcTable = this._document.TableP3SbP1;
            var yearsCount = ObasStageSettings.YearsCount;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((srcTable.Name.Value || "")) + "\" ";
                for (var j = 0; j < yearsCount; j++) {
                    template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.UsdYearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                for (var j = 0; j < yearsCount; j++) {
                    template += "b" + (7 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                for (var j = 0; j < yearsCount; j++) {
                    template += "b" + (11 + j) + "=\"" + (srcTable.GetFieldValue(F10120.ObasTableFields.OtherUsdField.GenerateId(j + 1)) || 0) + "\" ";
                }
                for (var j = 0; j < yearsCount; j++) {
                    template += "b" + (15 + j) + "=\"" + (srcTable.GetFieldValue(F10120.ObasTableFields.OtherRubField.GenerateId(j + 1)) || 0) + "\" ";
                }
                template += "bcheckbox1=\"True\" bcheckbox2=\"True\" ";
                template += "bID=\"" + srcTable.RecordKey.Value + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "bcheckbox11=\"True\" bcheckbox21=\"True\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var kosguTable = ObasTableCollection.KosguSprTable;
            var srcData = [];
            for (var i = 1; i < kosguData.length; i++) {
                var template = "<a ID=\"" + (i - 1) + "\" ";
                if (kosguTable.Locate(kosguTable.Code.Id, kosguData[i].Code)) {
                    template += "b1=\"" + (kosguTable.Name.Value || "") + "\" ";
                }
                else {
                    template += "b1=\"\" ";
                }
                template += "b2=\"" + (kosguData[i].Code || "") + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (id) {
            var strCodes = ["212", "221", "222", "224", "225", "226", "290", "310", "340", "total"];
            var srcData = [];
            for (var i = 0; i < strCodes.length; i++) {
                if (strCodes[i] === "total") {
                    srcData.push("<a ID=\"" + strCodes[i] + "\" b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" />");
                }
                else {
                    srcData.push("<a ID=\"" + strCodes[i] + "\" b1=\"" + strCodes[i] + "\" b2=\"" + strCodes[i] + "\" b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" />");
                }
            }
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F10120.ExportRules = ExportRules;
})(F10120 || (F10120 = {}));
